package com.ipoint.rentme.app.utils;

import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.params.HttpMethodParams;
import org.apache.tapestry5.ioc.Messages;

public class CodeValidator {

	public final static String HTTP_STATUS_ERROR_MESSAGE_KEY = "httpErrorMessage";
	public final static String SERVICE_UNAVAILABLE_MESSAGE_KEY = "serviceUnavailableMessage";
	public final static String WRONG_CODE_MESSAGE_KEY = "wrongCodeMessage";

	public static boolean validate(String code, Messages message) throws CodeValidateException {
		HttpClient client = new HttpClient();
		HttpMethod method = new GetMethod("http://check.smszamok.ru/check/?p="+code+"&id=28801&limit=1&mod=asp1");
		method.getParams().setParameter(HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler(3, false));
		boolean success = false;
		try {
			int statusCode = client.executeMethod(method);
			if (statusCode != HttpStatus.SC_OK) {
				throw new CodeValidateException(message.contains(HTTP_STATUS_ERROR_MESSAGE_KEY) ? message
						.get(HTTP_STATUS_ERROR_MESSAGE_KEY) : "Error!");
			}
			if ("true".equals(method.getResponseBodyAsString())) {
				success = true;
			} else {
				throw new CodeValidateException(message.contains(WRONG_CODE_MESSAGE_KEY) ? message
						.get(WRONG_CODE_MESSAGE_KEY) : "Wrong Code!");
			}
		} catch (Exception e) {
			if (e instanceof CodeValidateException) {
				throw (CodeValidateException) e;
			} else {
				throw new CodeValidateException(message.contains(SERVICE_UNAVAILABLE_MESSAGE_KEY) ? message
						.get(SERVICE_UNAVAILABLE_MESSAGE_KEY) : "Service temporarily unavailable. Please try later.");
			}
		} finally {
			method.releaseConnection();
		}
		return success;
	}

}
