package com.ipoint.rentme.app.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MessageUtil {

	private static String REGEX = "\\{\\d+\\}";
	private static String REPLACE = "%s";

	private static Pattern pattern = Pattern.compile(REGEX);

	private MessageUtil() {
	}

	/**
	 * Convert from MesssageFormat to String.format
	 * 
	 * @param message
	 * @return reformatted string
	 */
	public static String convert(String message) {
		StringBuffer sb = new StringBuffer();
		Matcher m = pattern.matcher(message);
		while (m.find()) {
			m.appendReplacement(sb, REPLACE);
		}
		m.appendTail(sb);
		return sb.toString();
	}

	public static String format(String message, Object... args) {
		return String.format(convert(message), args);
	}

	public static String getResultsCountString(int count) {
		String prefix = "найдено ";
		String postfix = " вариантов";
		if (count <= 0) {
			return "ничего не найдено";
		}
		if (count % 100 / 10 != 1 && count % 10 > 0 && count % 10 < 5) {
			if (count % 10 == 1) {
				prefix = "найден ";
				postfix = " вариант";
			} else {
				postfix = " варианта";
			}
		}
		return prefix + count + postfix;
	}
}
