package com.ipoint.rentme.base;

import javax.servlet.http.HttpServletRequest;

import org.apache.tapestry5.PersistenceConstants;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.RequestGlobals;
import org.slf4j.Logger;

import com.ipoint.rentme.app.data.FlashMessage;
import com.ipoint.rentme.app.data.FlashMessage.Type;
import com.ipoint.rentme.app.utils.MessageUtil;

/**
 * Base page containing common functionalities
 * 
 * @author Serge Eby
 * @version $Id: BasePage.java 9 2008-12-09 06:08:54Z serge.eby $
 */
public class BasePage {
	
	@Inject
    private Logger logger;
    

    @Inject 
    private Messages messages;
    
    
    @Persist(PersistenceConstants.FLASH)
	private FlashMessage flashMessage;
    
    @Inject
    private RequestGlobals globals;
        

    
    public Logger getLogger() {
		return logger;
	}

	public Messages getMessages() {
		return messages;
	}

	public FlashMessage getFlashMessage() {
		return flashMessage;
	}

	public void setFlashMessage(FlashMessage flashMessage) {
		this.flashMessage = flashMessage;
	}

	public void addFlash(String message, Type type) {
		setFlashMessage(new FlashMessage(message, type));
	}

	public void addFlashByKey(String key, Type type, Object... args) {
		setFlashMessage(new FlashMessage(getText(key, args), type));
	}
    
    // Message Catalog helper    
	protected String getText(String key, Object... args) {
		return MessageUtil.format(getMessages().get(key), args);
	}

	protected HttpServletRequest getRequest() {
    	return globals.getHTTPServletRequest();
    }
    
}
