/**
 * 
 */
package com.ipoint.rentme.components;

import org.apache.commons.lang.StringUtils;
import org.apache.tapestry5.Block;
import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;

/**
 * This is border class for all our pages. It provides all data for building border.
 * 
 * @author happy
 */
public class Border extends BaseBorder {
	
	private static final String META_DESCRIPTION = "meta-description";

	@Parameter
	private Block side;
	
	public boolean isHasSide() {
		return side != null;
	}
	
	public Object getSide() {
		return side;
	}
	
	@Parameter
	private Block top;

	public boolean isHasTop() {
		return top != null;
	}

	public Object getTop() {
		return top;
	}
	
	@Inject
	private Messages messages;
	
	@Parameter
	private String description;
	
	public String getDescription() {
		if (StringUtils.isBlank(description)) {
			return messages.get(META_DESCRIPTION);
		}
		return description;
	}

}
