/**
 * 
 */
package com.ipoint.rentme.components;

import java.text.Format;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;

import com.ipoint.rentme.app.utils.Formats;
import com.ipoint.rentme.model.Advertisement;

/**
 * @author happy
 *
 */
public class DisplayAdvertisement {
	
	@Parameter
	private Advertisement advertisement;

	public Advertisement getAdvertisement() {
		return advertisement;
	}

	public void setAdvertisement(Advertisement advertisement) {
		this.advertisement = advertisement;
	}
	
	public Format getFormat() {
		return Formats.DATE_FORMAT;
	}
	
	@Inject
	private Messages messages;

	public String getDistrictName() {
		return messages.get(advertisement.getDistrict().toString());
	}
	
	public String getRoomsCount() {
		return messages.get(advertisement.getRoomsCount().toString());
	}
	
	public int getPriceByThousandRubles(){
		return advertisement.getPrice()/1000;
	}
	
}