/**
 * 
 */
package com.ipoint.rentme.components;

import java.util.List;

import org.apache.tapestry5.SelectModel;
import org.apache.tapestry5.annotations.IncludeStylesheet;
import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.util.EnumSelectModel;

import com.ipoint.rentme.dao.AdvertisementDao;
import com.ipoint.rentme.model.Advertisement;
import com.ipoint.rentme.model.AdvertisementType;
import com.ipoint.rentme.model.Districts;
import com.ipoint.rentme.model.PaymentMethods;
import com.ipoint.rentme.model.SearchRooms;

/**
 * @author happy
 */
@IncludeStylesheet("ExtSearch.css")
public class ExtSearch {

	@Parameter
	private List<Advertisement> searchResults;

	@Persist
	@Property
	private Districts district;

	@Property
	private PaymentMethods paymentMethod;

	@Property
	private Boolean excludeFirstFloor;

	@Property
	private Integer endPrice;

	@Property
	private SearchRooms roomsCount;

	@Inject
	@Property
	private AdvertisementDao advDao;

	@Property
	private Boolean excludeLastFloor;

	@Property
	private Boolean balcony;

	@Property
	private Boolean telephone;

	@Parameter
	private AdvertisementType type;

	@Property
	private boolean more;

	public SelectModel getDistrictModel() {
		return new EnumSelectModel(Districts.class, messages);
	}

	@Inject
	private Messages messages;

	public SelectModel getPaymentModel() {
		return new EnumSelectModel(PaymentMethods.class, messages);
	}

	public SelectModel getRoomModel() {
		return new EnumSelectModel(SearchRooms.class, messages);
	}

	public SelectModel getTypeModel() {
		return new EnumSelectModel(AdvertisementType.class, messages);
	}

	public void onSelectedFromReset() {
		endPrice = 0;
		roomsCount = null;
		district = null;
		paymentMethod = null;
		excludeFirstFloor = false;
		excludeLastFloor = false;
		balcony = false;
		telephone = false;
		type = null;
	}

	public void onSelectedFromSubmit() {
		this.setSearchResults(advDao.findAdvertisement(district, roomsCount, type, excludeFirstFloor, endPrice,
				balcony, excludeLastFloor, telephone, paymentMethod));
	}

	private void setSearchResults(List<Advertisement> findAdvertisement) {
		this.searchResults = findAdvertisement;
	}

	public List<Advertisement> getSearchResults() {
		return searchResults;
	}

	public AdvertisementType getType() {
		return type;
	}

	public void setType(AdvertisementType type) {
		this.type = type;
	}

}
