package com.ipoint.rentme.dao;

import java.util.List;

import com.ipoint.rentme.model.Advertisement;
import com.ipoint.rentme.model.AdvertisementType;
import com.ipoint.rentme.model.AuditRecord;
import com.ipoint.rentme.model.Districts;
import com.ipoint.rentme.model.PaymentMethods;
import com.ipoint.rentme.model.SearchRooms;
import com.ipoint.rentme.model.User;

public interface AdvertisementDao extends BaseDao<Advertisement> {
	
	
	@Override
	@Deprecated
	//Use saveWithAuditInfo..
	public Advertisement save(Advertisement objectToSave);
	
	/**
	 * 
	 * Creates an {@link AuditRecord} so we can track who made changes to the {@link Advertisement}.
	 * 
	 * @param objectToSave
	 * @param remoteAddress - where the request come from.
	 * @param user - user that made changes.
	 * @return
	 */
	Advertisement saveWithAuditInfo(Advertisement objectToSave, String remoteAddress, User user);
	
	public List<Advertisement> findAdvertisement(Districts district, SearchRooms roomCount, AdvertisementType type, boolean excludeFirstFloor,
			Integer priceMax, boolean balcony, boolean excludeLastFloor, boolean telephone,
			PaymentMethods paymentMethods);

	/**
	 * @return list of all advertisements that have not been reviewed by moderator yet.
	 */
	List<Advertisement> getUnmoderatedList();
	
	/**
	 * @return the most recent advertisement number.
	 */
	int getLastNumber();

	/**
	 * @return list of all advertisements that have expired.
	 */
	List<Advertisement> getUnactualList();

	/**
	 * @param advertisement
	 */
	Advertisement getNextToModerate();

	/**
	 * @param user
	 * @return all active advertisements of user specified.
	 */
	List<Advertisement> getActualList(User user);

	List<Advertisement> getUnactualList(User user);
	 
}