package com.ipoint.rentme.model;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.tapestry5.beaneditor.Validate;
import org.apache.tapestry5.beaneditor.Width;

public class Contract {
	
	private String city;

	@Validate("maxlength=20")
	@Width(20)
	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}
	
	private Date date;

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}
	
	public String getDay(){
		if(getDate() == null){
			return "";
		}
		return new SimpleDateFormat("dd").format(getDate());
	}
	
	public String getMonth(){
		if(getDate() == null){
			return "";
		}
		return new SimpleDateFormat("MMMMM").format(getDate());
	}
	
	public String getYear(){
		if(getDate() == null){
			return "";
		}
		return new SimpleDateFormat("yyyy").format(getDate());
	}
	
	private String landlord;

	@Width(60)
	@Validate("maxlength=60")
	public String getLandlord() {
		return landlord;
	}

	public void setLandlord(String landlord) {
		this.landlord = landlord;
	}
	
	private String landlordPassportSeries;

	@Width(4)
	@Validate("maxlength=4")
	public String getLandlordPassportSeries() {
		return landlordPassportSeries;
	}

	public void setLandlordPassportSeries(String landlordPassportSeries) {
		this.landlordPassportSeries = landlordPassportSeries;
	}	
	
	private String landlordPassportNumber;

	@Width(6)
	@Validate("maxlength=6")
	public String getLandlordPassportNumber() {
		return landlordPassportNumber;
	}

	public void setLandlordPassportNumber(String landlordPassportNumber) {
		this.landlordPassportNumber = landlordPassportNumber;
	}
	
	private String landlordPassportEmitter;

	@Width(60)
	@Validate("maxlength=60")
	public String getLandlordPassportEmitter() {
		return landlordPassportEmitter;
	}

	public void setLandlordPassportEmitter(String landlordPassportEmitter) {
		this.landlordPassportEmitter = landlordPassportEmitter;
	}
	
	private String landlordAddress;

	@Width(60)
	@Validate("maxlength=60")
	public String getLandlordAddress() {
		return landlordAddress;
	}

	public void setLandlordAddress(String landlordAddress) {
		this.landlordAddress = landlordAddress;
	}
	
	private String tenant;

	@Width(60)
	@Validate("maxlength=60")
	public String getTenant() {
		return tenant;
	}

	public void setTenant(String tenant) {
		this.tenant = tenant;
	}
	
	private String tenantPassportSeries;

	@Width(4)
	@Validate("maxlength=4")
	public String getTenantPassportSeries() {
		return tenantPassportSeries;
	}

	public void setTenantPassportSeries(String tenantPassportSeries) {
		this.tenantPassportSeries = tenantPassportSeries;
	}	
	
	private String tenantPassportNumber;

	@Width(6)
	@Validate("maxlength=6")
	public String getTenantPassportNumber() {
		return tenantPassportNumber;
	}

	public void setTenantPassportNumber(String tenantPassportNumber) {
		this.tenantPassportNumber = tenantPassportNumber;
	}
	
	private String tenantPassportEmitter;

	@Width(60)
	@Validate("maxlength=60")
	public String getTenantPassportEmitter() {
		return tenantPassportEmitter;
	}

	public void setTenantPassportEmitter(String tenantPassportEmitter) {
		this.tenantPassportEmitter = tenantPassportEmitter;
	}
	
	private String tenantAddress;

	@Width(60)
	@Validate("maxlength=60")
	public String getTenantAddress() {
		return tenantAddress;
	}

	public void setTenantAddress(String tenantAddress) {
		this.tenantAddress = tenantAddress;
	}
}
