package com.ipoint.rentme.pages;

import javax.servlet.http.HttpServletRequest;

import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.ioc.annotations.Inject;

import com.ipoint.rentme.dao.AdvertisementDao;
import com.ipoint.rentme.model.Advertisement;
import com.ipoint.rentme.services.AuthService;
import com.ipoint.rentme.services.MailService;

/**
 * @author aectann
 */
public class Add {
	@Inject
	private AdvertisementDao advertisementDao;

	@Inject
	private MailService mailService;

	@Persist
	private Advertisement adv;

	@Persist
	private boolean added;

	public Advertisement getAdvertisement() {
		return this.adv;
	}

	public void setAdvertisement(Advertisement adv) {
		this.adv = adv;
	}

	public boolean isAdded() {
		return added;
	}

	public void setAdded(boolean added) {
		this.added = added;
	}
	
	@Inject
	private HttpServletRequest request;
	
	@Inject
	private AuthService authService;
	
	public Object onSuccess() {
		advertisementDao.saveWithAuditInfo(adv, request.getRemoteHost(), authService.getCurrentUser());
		mailService.notifyAdministrator("New advertisement received: " + adv.getDescription() + " from "
				+ adv.getPhoneNumber());
		this.adv = new Advertisement();
		this.setAdded(true);
		return this;
	}

	public Object onActionFromAddOneMore() {
		this.setAdded(false);
		return this;
	}
}
