package com.ipoint.rentme.pages;

import org.apache.tapestry5.annotations.InjectPage;
import org.apache.tapestry5.ioc.annotations.Inject;

import com.ipoint.rentme.services.AuthService;
import com.ipoint.rentme.services.MailService;

public class Feedback {
	
	private String subject;

	private String message;

	private String replyToAddress;

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public String getReplyToAddress() {
		return replyToAddress;
	}

	public void setReplyToAddress(String replyToAddress) {
		this.replyToAddress = replyToAddress;
	}
	
	@Inject
	private AuthService authService;

	public boolean isNoUser() {
		return authService.getCurrentUser() == null;
	}
	
	@Inject
	private MailService mailService;
	
	@InjectPage
	private FeedbackSuccess feedbackSuccess;

	Object onSuccess() {
		String address;
		if (isNoUser()) {
			address = getReplyToAddress();
		} else {
			address = authService.getCurrentUser().getEmail();
		}
		mailService.sendFeedBack(getSubject(), getMessage(), address);
		return feedbackSuccess;
	}
	
}
