package com.ipoint.rentme.pages;

import java.util.List;

import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.ioc.annotations.Inject;

import com.ipoint.rentme.app.utils.MessageUtil;
import com.ipoint.rentme.dao.AdvertisementDao;
import com.ipoint.rentme.model.Advertisement;
import com.ipoint.rentme.model.AdvertisementType;

/**
 * Start page of application rentme.
 */
public class Index {

	@Persist
	private List<Advertisement> searchResults;

	@Inject
	private AdvertisementDao advertisementDao;

	@Persist
	private AdvertisementType type;

	private Advertisement advertisement;

	public boolean isSellMode() {
		return type.equals(AdvertisementType.SELL);
	}

	public boolean isRentMode() {
		return type.equals(AdvertisementType.RENT);
	}

	public Advertisement getAdvertisement() {
		return advertisement;
	}

	public void setAdvertisement(Advertisement advertisement) {
		this.advertisement = advertisement;
	}

	public void setType(AdvertisementType type) {
		this.type = type;
	}

	public AdvertisementType getType() {
		return type;
	}

	public List<Advertisement> getSearchResults() {
		return searchResults;
	}

	public void setSearchResults(List<Advertisement> searchResults) {
		this.searchResults = searchResults;
	}

	public void onActivate() {
		if (this.getSearchResults() == null) {
			this.setSearchResults(advertisementDao.findAdvertisement(null, null, null, false, null, false, false,
					false, null));
		}
	}

	public String getResultsCountString() {
		return MessageUtil.getResultsCountString(searchResults.size());
	}
}
