package com.ipoint.rentme.services;

import org.springframework.security.userdetails.UserDetailsService;

import com.ipoint.rentme.dao.DuplicateEmailException;
import com.ipoint.rentme.dao.DuplicateUsernameException;
import com.ipoint.rentme.model.User;

public interface AuthService extends UserDetailsService {
	
	/**
	 * @return currently logged in user, null if no one is logged in.
	 */
	User getCurrentUser();
	
	User createUser(User user) throws DuplicateEmailException, DuplicateUsernameException;

	User updateCurrentUser(String username, String password, String email, String phone, String name) throws DuplicateEmailException,
			DuplicateUsernameException;
}
