package com.ipoint.rentme.services.impl;

import java.net.MalformedURLException;
import java.net.URL;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.apache.tapestry5.services.PageRenderLinkSource;

import com.ipoint.rentme.services.ExternalLinkFactory;

public class ExternalLinkFactoryImpl implements ExternalLinkFactory {

	private static final String PAGES_PACKAGE_NAME = "pages.";

	private PageRenderLinkSource linkFactory;

	private HttpServletRequest request;

	public ExternalLinkFactoryImpl(PageRenderLinkSource linkFactory, HttpServletRequest request) {
		this.linkFactory = linkFactory;
		this.request = request;
	}

	@SuppressWarnings("unchecked")
	@Override
	public String generateLink(Class pageClass, Object... context) {
		URL url;
		try {
			url = new URL(request.getRequestURL().toString());
			StringBuilder absoluteLink = new StringBuilder();
			absoluteLink.append(url.getProtocol());
			absoluteLink.append("://");
			absoluteLink.append(url.getHost());
			if (url.getPort() != -1) {
				absoluteLink.append(":");
				absoluteLink.append(url.getPort());
			}
			String pageName = pageClass.getCanonicalName();
			pageName = StringUtils.substringAfter(pageName, PAGES_PACKAGE_NAME);
			pageName = pageName.replaceAll("\\.", "/");
			absoluteLink.append(linkFactory.createPageRenderLinkWithContext(pageName, context)
					.toAbsoluteURI().toString());

			return absoluteLink.toString();
		} catch (MalformedURLException e) {
			// never happens..
			e.printStackTrace();
		}
		return null;
	}

}
